HDU - 2955(动态规划01背包)

53 篇文章 1 订阅
24 篇文章 0 订阅

Robberies

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 22786    Accepted Submission(s): 8401


Problem Description
The aspiring Roy the Robber has seen a lot of American movies, and knows that the bad guys usually gets caught in the end, often because they become too greedy. He has decided to work in the lucrative business of bank robbery only for a short while, before retiring to a comfortable job at a university.


For a few months now, Roy has been assessing the security of various banks and the amount of cash they hold. He wants to make a calculated risk, and grab as much money as possible.


His mother, Ola, has decided upon a tolerable probability of getting caught. She feels that he is safe enough if the banks he robs together give a probability less than this.
 

Input
The first line of input gives T, the number of cases. For each scenario, the first line of input gives a floating point number P, the probability Roy needs to be below, and an integer N, the number of banks he has plans for. Then follow N lines, where line j gives an integer Mj and a floating point number Pj .
Bank j contains Mj millions, and the probability of getting caught from robbing it is Pj .
 

Output
For each test case, output a line with the maximum number of millions he can expect to get while the probability of getting caught is less than the limit set.

Notes and Constraints
0 < T <= 100
0.0 <= P <= 1.0
0 < N <= 100
0 < Mj <= 100
0.0 <= Pj <= 1.0
A bank goes bankrupt if it is robbed, and you may assume that all probabilities are independent as the police have very low funds.
 

Sample Input
  
  
3 0.04 3 1 0.02 2 0.03 3 0.05 0.06 3 2 0.03 2 0.03 3 0.05 0.10 3 1 0.03 2 0.02 3 0.05
 

Sample Output
  
  
2 4 6
 

Source
 

Recommend
gaojie
 

题目大意:有人要抢银行,然后有n个银行可以抢,但是它要求有一个逃跑率,同时n个银行,分别有不同数量的钱以及被抓率,问你满足一定的逃跑率的情况下,抢钱最多
解题思路:这本身是一个比较简单的01背包,我上去就写了,根据我的上一篇01背包的总结去写了,结果WA了,看了一些网上的攻略,发现题没读懂,很多人都犯了跟我一样的毛病
1.这道题给的小数不一定只保留2位小数,有可能是0.000001这样,也就是我一开始打算用逃跑率去当背包WA的原因
2.这道题给的所有小数不是你们想的那样的,他给的第一行的概率,是被抓的概率,也就是说要1-P才可以求出来逃跑率,找出比(1-P)的概率大的最大钱数,同时每个银行给的,都是被抓的概率,要求逃跑率是1-Pj才可以,同时逃跑率是相乘不是单纯的相加,这是概率上的问题了,不懂得可以翻翻概率书
以上懂了之后,我们要做的就是找谁当作背包,思来想去,发现其实钱数可以当作背包,所以这道题的转换方程是
dp[i]=max(dp[i],dp[i-a[j]]*b[j])
其中a[j]就是j银行有的钱数,b[j]就是j银行的逃跑率
这是一个不错的思维转换的,仔细想想比较觉得出的好的,同时英语很重要(冷漠脸)
#include<iostream>    
#include<cstdio>  
#include<stdio.h>  
#include<cstring>    
#include<cstdio>    
#include<climits>    
#include<cmath>   
#include<vector>  
#include <bitset>  
#include<algorithm>    
#include <queue>  
#include<map>  
using namespace std;

int main()
{
	double m, b[105], dp[10005];
	int T, a[105], i, j, n, sum;
	cin >> T;
	while (T--)
	{
		sum = 0;
		memset(a, 0, sizeof(a));
		memset(dp, 0, sizeof(dp));
		memset(b, 0, sizeof(b));
		cin >>m>> n;
		for (i =1 ; i <= n; i++)
		{
			cin >> a[i] >> b[i];
			b[i] = 1 - b[i];
			sum += a[i];
		}
		dp[0] = 1;
		for (i = 1; i <= n; i++)
		{
			for (j = sum; j >= a[i]; j--)
			{
				dp[j] = max(dp[j], dp[j - a[i]] * b[i]);
			}
		}
		for (i = sum; i >= 0; i--)
		{
			if (dp[i]>(1-m))
			{
				cout << i << endl;
				break;
			}
		}
	}
}


  • 0
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值